Subject: Re: [PATCH] travis-ci: install packages in 'ci/install-dependencies.sh'

From: SZEDER Gábor <[email-masked]>
Date: Thu, 8 Nov 2018 22:51:33 +0100

On Fri, Nov 02, 2018 at 11:25:17AM +0900, Junio C Hamano wrote:
> SZEDER Gábor <[email-masked]> writes:
> 
> > Ever since we started using Travis CI, we specified the list of
> > packages to install in '.travis.yml' via the APT addon.  While running
> > our builds on Travis CI's container-based infrastructure we didn't
> > have another choice, because that environment didn't support 'sudo',
> > and thus we didn't have permission to install packages ourselves.  With
> > the switch to the VM-based infrastructure in the previous patch we do
> > get a working 'sudo', so we can install packages by running 'sudo
> > apt-get -y install ...' as well.
> 
> OK, so far we learned that this is now _doable_; but not enough to
> decide if this is a good thing to do or not.  Let's read on to find
> out.

Yeah, this paragraph is just a bit of background about how the current
situation came to be and what recent change made the switch possible.

> > Let's make use of this and install necessary packages in
> > 'ci/install-dependencies.sh', so all the dependencies (i.e. both
> > packages and "non-packages" (P4 and Git-LFS)) are handled in the same
> > file.  
> 
> So we used to have two waysto prepare the test environment; non
> packaged software were done via install-dependencies.sh, but
> packaged ones weren't.  Unifying them so that the script installs
> both would be a good change to simplify the procedure.  
> 
> Is that how this sentence argues for this change?

Yes.

> > Install gcc-8 only in the 'linux-gcc' build job; so far it has
> > been unnecessarily installed in the 'linux-clang' build job as well.
> 
> Is this "unneeded gcc-8 was installed" something we can fix only
> because we now stopped doing the installation via apt addon?

Now that you mention it: no.  It would have been possible to install
gcc-8 only in the 'linux-gcc' build job even via the apt addon, namely
by removing the two Linux build jobs from the implicit build matrix
and adding them as two independent build jobs in the 'matrix.include'
section of '.travis.yml'.  The drawback is that all the extra packages
used in both build jobs would have to be duplicated.

> Or we
> could have fixed it while we were on apt addon but we didn't bother,
> and this patch fixes it "while at it"---primarily because the shell
> script is far more flexible to work with than travis.yml matrix and
> this kind of customization is far easier to do?

Basically yes (though I think it's not about not bothering; I don't
know about others, but it just occured to me that it would have been
doable, however, even if it occured to me earlier, because of the
duplicated list of common packages I wouldn't have done it).

Doing it in good old shell is indeed easier and the common packages
are then only listed once.

> > Print the versions of P4 and Git-LFS conditionally, i.e. only when
> > they have been installed; with this change even the static analysis
> > and documentation build jobs start using 'ci/install-dependencies.sh'
> > to install packages, and neither of these two build jobs depend on and
> > thus install those.
> >
> > This change will presumably be beneficial for the upcoming Azure
> > Pipelines integration [1]: preliminary versions of that patch series
> > run a couple of 'apt-get' commands to install the necessary packages
> > before running 'ci/install-dependencies.sh', but with this patch it
> > will be sufficient to run only 'ci/install-dependencies.sh'.
> 
> So the main point of this change is to have less knowledge to
> prepare the target configuration in the .travis.yml file and keep
> them all in ci/install-dependencies.sh, which hopefully is more
> reusable than .travis.yml in a non Travis environment?

Oh, "more reusable" indeed, that's a more eloquent way to put it.

> If that is the case, it makes sense to me.
> 
> > This patch should go on top of 'ss/travis-ci-force-vm-mode'.
> >
> > I'm not sure about the last paragraph, because:
> >
> >   - It talks about presumed benefits for a currently still
> >     work-in-progress patch series of an other contributor, and I'm not
> >     really sure that that's a good thing.  Perhaps I should have
> >     rather put it below the '---'.
> >
> >   - I'm confused about the name of this Azure thing.  The cover letter
> >     mentions "Azure Pipelines", the file is called
> >     'azure-pipelines.yml', but the relevant patch I link to talks
> >     about "Azure DevOps" in the commit message.
> >
> > Anyway, keep that last paragraph or drop it as you see fit.
> 
> I hope we'll hear from Dscho in one or two revolutions of the Earth
> ;-)

... revolutions around what? :)